"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class BaseController {
    constructor() {
        this.scripts = [];
        this.styles = [];
        this.title = "Base route";
        this.addStyle("/asset/css/main.css");
    }
    addScript(src) {
        this.scripts.push(src);
        return this;
    }
    addStyle(src) {
        this.styles.push(src);
        return this;
    }
    render(req, res, view, options = {}) {
        res.locals.BASE_URL = "/";
        res.locals.styles = this.styles;
        res.locals.scripts = this.scripts;
        res.locals.title = "Yousubs - " + this.title;
        res.render(view, options);
    }
}
exports.BaseController = BaseController;
//# sourceMappingURL=BaseController.js.map