"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const nProcess = require("child_process");
let CLI = "yousubs-cli";
if (process.env.YS_DEV) {
    CLI = "node ./cli/index.js";
}
class YousubsCommand {
    static execute(...args) {
        const command = args.map((arg) => {
            if (typeof arg === "object") {
                return '"' + JSON.stringify(arg).replace(/"/g, "\\\"") + '"';
            }
            arg = arg.toString();
            return arg.indexOf(" ") === -1 || arg.indexOf("\"") ?
                arg : '"' + arg.replace(/"/g, "\\\"") + '"';
        }).join(" ");
        return new Promise((resolve, reject) => {
            nProcess.exec(CLI + " " + command, (err, stdout, stderr) => {
                if (err) {
                    reject(stderr);
                }
                else {
                    resolve(stdout);
                }
            });
        });
    }
}
exports.default = YousubsCommand;
//# sourceMappingURL=YousubsCommand.js.map